import numpy as np
import numpy.random as nr

data1 = [
          69,  55,  61,  53,  51,  50,  67,  47,  59,  69,
          68,  55,  54,  73,  50,  51,  68,  62,  57,  64,
          62,  74,  73,  83,  71,  35,  63,  70,  46,  73,
          73,  64,  62,  77,  84,  54,  45,  63,  78,  52,
          87,  68,  61,  56,  60,  53,  72,  42,  44,  53
          ]
data1 = np.array(data1)

data2 = [
          55,  70,  55,  64,  77,  64,  61,  68,  66,  62,
          74,  75,  66,  68,  56,  63,  75,  63,  59,  75,
          72,  59,  65,  79,  49,  57,  72,  54,  61,  80,
          62,  73,  55,  76,  77,  69,  64,  70,  53,  59,
          64,  48,  65,  69,  68,  59,  65,  47,  60,  84
          ]
data2 = np.array(data2)

data3 = [
          85,  84,  33,  94,  39,  32,  49,  40,  84,  47,
          88,  49,  90,  83,  48,  44,  41,  42,  87,  45,
          44,  49,  44,  46,  80,  85,  92,  48,  46,  83,
          81,  87,  81,  83,  38,  80,  40,  90,  90,  92,
          99,  91,  44,  89,  40,  47,  80,  49,  95,  34
          ]
data3 = np.array(data3)

N = len(data3)
print('N =', N)
print('N//2 =', N//2)

NSimu = 100                 #   シミュレーションの回数

Diff21 = np.empty(NSimu)
Diff31 = np.empty(NSimu)
Diff32 = np.empty(NSimu)

I = 1
while True:
    subd1 = nr.choice(data1, N//2, replace = False)
    mean1 = np.mean(subd1)
    subd2 = nr.choice(data2, N//2, replace = False)
    mean2 = np.mean(subd2)
    subd3 = nr.choice(data3, N//2, replace = False)
    mean3 = np.mean(subd3)
    Diff21[I-1] = mean2 - mean1
    Diff31[I-1] = mean3 - mean1
    Diff32[I-1] = mean3 - mean2
    I += 1
    if I > NSimu:                   #   シミュレーションの回数がNに達したか？
        break

print()
print('(２組）ー（１組）:')
print('平均 =', f'{np.mean(Diff21):.3f}',
      '    標準偏差 =', f'{np.std(Diff21):.3f}')
print('(３組）ー（１組）:')
print('平均 =', f'{np.mean(Diff31):.3f}',
      '    標準偏差 =', f'{np.std(Diff31):.3f}')
print('(３組）ー（２組）:')
print('平均 =', f'{np.mean(Diff32):.3f}',
      '    標準偏差 =', f'{np.std(Diff32):.3f}')

